QwtPlotZoomer(3)

NAME
QwtPlotZoomer -

SYNOPSIS

Inherits QwtPlotPicker.

Detailed Description

QwtPlotZoomer provides stacked zooming for a plot widget. QwtPlotZoomer offers rubberband selections on the plot canvas, translating the selected rectangles into plot coordinates and adjusting the axes to them. Zooming can repeated as often as possible, limited only by maxStackDepth() or minZoomSize(). Each rectangle is pushed on a stack.

Zoom rectangles can be selected depending on selectionFlags() using the mouse or keyboard (QwtEventPattern, QwtPickerMachine). QwtEventPattern::MouseSelect3/QwtEventPatternKeyUndo, or QwtEventPattern::MouseSelect6/QwtEventPatternKeyRedo walk up and down the zoom stack. QwtEventPattern::MouseSelect2 or QwtEventPattern::KeyHome unzoom to the initial size.

QwtPlotZoomer is tailored for plots with one x and y axis, but it is allowed to attach a second QwtPlotZoomer for the other axes.

Note:
    The realtime example includes an derived zoomer class that adds scrollbars to the plot canvas.

Definition at line 49 of file qwt_plot_zoomer.h.

  Public Slots
void moveBy (double x, double y)
virtual void move (double x, double y)
virtual void zoom (const QwtDoubleRect &)
virtual void zoom (int up)

  Signals
void zoomed (const QwtDoubleRect &rect)

  Public Member Functions
QwtPlotZoomer (QwtPlotCanvas *, bool doReplot=true)
QwtPlotZoomer (int xAxis, int yAxis, QwtPlotCanvas *, bool doReplot=true)
QwtPlotZoomer (int xAxis, int yAxis, int selectionFlags, DisplayMode trackerMode, QwtPlotCanvas *, bool doReplot=true)
virtual ~QwtPlotZoomer ()
virtual void setZoomBase ()
virtual void setZoomBase (const QwtDoubleRect &)
QwtDoubleRect zoomBase () const
QwtDoubleRect zoomRect () const
virtual void setAxis (int xAxis, int yAxis)
void setMaxStackDepth (int)
int maxStackDepth () const
const QStack< QwtDoubleRect > & zoomStack () const
uint zoomRectIndex () const
virtual void setSelectionFlags (int)

  Protected Member Functions
virtual void rescale ()
virtual QwtDoubleSize minZoomSize () const
virtual void widgetMouseReleaseEvent (QMouseEvent *)
virtual void widgetKeyPressEvent (QKeyEvent *)
virtual void begin ()
virtual bool end (bool ok=true)
virtual bool accept (QwtPolygon &) const

Constructor & Destructor Documentation

  QwtPlotZoomer::QwtPlotZoomer (QwtPlotCanvas * canvas, bool doReplot = true) [explicit]

Create a zoomer for a plot canvas.

The zoomer is set to those x- and y-axis of the parent plot of the canvas that are enabled. If both or no x-axis are enabled, the picker is set to QwtPlot::xBottom. If both or no y-axis are enabled, it is set to QwtPlot::yLeft.

The selectionFlags() are set to QwtPicker::RectSelection & QwtPicker::ClickSelection, the tracker mode to QwtPicker::ActiveOnly.

Parameters:
    canvas Plot canvas to observe, also the parent object
    doReplot Call replot for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::setZoomBase()

Definition at line 51 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::canvas().

  QwtPlotZoomer::QwtPlotZoomer (int xAxis, int yAxis, QwtPlotCanvas * canvas, bool doReplot = true) [explicit]

Create a zoomer for a plot canvas.

The selectionFlags() are set to QwtPicker::RectSelection & QwtPicker::ClickSelection, the tracker mode to QwtPicker::ActiveOnly.

Parameters:
    xAxis X axis of the zoomer
    yAxis Y axis of the zoomer
    canvas Plot canvas to observe, also the parent object
    doReplot Call replot for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot(), QwtPlotPicker::setZoomBase()

Definition at line 75 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::canvas().

  QwtPlotZoomer::QwtPlotZoomer (int xAxis, int yAxis, int selectionFlags, DisplayMode trackerMode, QwtPlotCanvas * canvas, bool doReplot = true) [explicit]

Create a zoomer for a plot canvas.

Parameters:
    xAxis X axis of the zoomer
    yAxis Y axis of the zoomer
    selectionFlags Or'd value of QwtPicker::RectSelectionType and QwtPicker::SelectionMode. QwtPicker::RectSelection will be auto added.
    trackerMode Tracker mode
    canvas Plot canvas to observe, also the parent object
    doReplot Call replot for the attached plot before initializing the zoomer with its scales. This might be necessary, when the plot is in a state with pending scale changes.

See also:
    QwtPicker, QwtPicker::setSelectionFlags(), QwtPicker::setRubberBand(), QwtPicker::setTrackerMode

    QwtPlot::autoReplot(), QwtPlot::replot(), setZoomBase()

Definition at line 103 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::canvas().

Member Function Documentation

  bool QwtPlotZoomer::accept (QwtPolygon & pa) const [protected, virtual]

Check and correct a selected rectangle.

Reject rectangles with a hight or width < 2, otherwise expand the selected rectangle to a minimum size of 11x11 and accept it.

Returns:
    true If rect is accepted, or has been changed to a accepted rectangle.

Reimplemented from QwtPicker.

Definition at line 497 of file qwt_plot_zoomer.cpp.

References minZoomSize().

  void QwtPlotZoomer::begin () [protected, virtual]

Rejects selections, when the stack depth is too deep, or the zoomed rectangle is minZoomSize().

See also:
    minZoomSize(), maxStackDepth()

Reimplemented from QwtPicker.

Definition at line 545 of file qwt_plot_zoomer.cpp.

References minZoomSize().

  bool QwtPlotZoomer::end (bool ok = true) [protected, virtual]

Expand the selected rectangle to minZoomSize() and zoom in if accepted.

See also:
    QwtPlotZoomer::accept()a, QwtPlotZoomer::minZoomSize()

Reimplemented from QwtPlotPicker.

Definition at line 575 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::end(), QwtPlotPicker::invTransform(), minZoomSize(), QwtPlotPicker::plot(), QwtPicker::selection(), zoom(), and zoomRect().

  int QwtPlotZoomer::maxStackDepth () const

Returns:
    Maximal depth of the zoom stack.

See also:
    setMaxStackDepth()

Definition at line 172 of file qwt_plot_zoomer.cpp.

  QwtDoubleSize QwtPlotZoomer::minZoomSize () const [protected, virtual]

Limit zooming by a minimum rectangle.

Returns:
    zoomBase().width() / 10e4, zoomBase().height() / 10e4

Definition at line 531 of file qwt_plot_zoomer.cpp.

Referenced by accept(), begin(), and end().

  void QwtPlotZoomer::move (double x, double y) [virtual, slot]

Move the the current zoom rectangle.

Parameters:
    x X value
    y Y value

See also:
    QwtDoubleRect::move

Note:
    The changed rectangle is limited by the zoom base

Definition at line 467 of file qwt_plot_zoomer.cpp.

References rescale(), zoomBase(), and zoomRect().

Referenced by moveBy().

  void QwtPlotZoomer::moveBy (double dx, double dy) [slot]

Move the current zoom rectangle.

Parameters:
    dx X offset
    dy Y offset

Note:
    The changed rectangle is limited by the zoom base

Definition at line 452 of file qwt_plot_zoomer.cpp.

References move().

  void QwtPlotZoomer::rescale () [protected, virtual]

Adjust the observed plot to zoomRect()

Note:
    Initiates QwtPlot::replot

Definition at line 343 of file qwt_plot_zoomer.cpp.

References QwtPlot::autoReplot(), QwtPlot::axisScaleDiv(), QwtScaleDiv::hBound(), QwtScaleDiv::lBound(), QwtPlotPicker::plot(), QwtPlotPicker::scaleRect(), QwtPlot::setAutoReplot(), QwtPlot::setAxisScale(), QwtPlotPicker::xAxis(), and QwtPlotPicker::yAxis().

Referenced by move(), setZoomBase(), and zoom().

  void QwtPlotZoomer::setAxis (int xAxis, int yAxis) [virtual]

Reinitialize the axes, and set the zoom base to their scales.

Parameters:
    xAxis X axis
    yAxis Y axis

Reimplemented from QwtPlotPicker.

Definition at line 387 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::scaleRect(), QwtPlotPicker::setAxis(), setZoomBase(), QwtPlotPicker::xAxis(), and QwtPlotPicker::yAxis().

  void QwtPlotZoomer::setMaxStackDepth (int depth)

Limit the number of recursive zoom operations to depth.

A value of -1 set the depth to unlimited, 0 disables zooming. If the current zoom rectangle is below depth, the plot is unzoomed.

Parameters:
    depth Maximum for the stack depth

See also:
    maxStackDepth()

Note:
    depth doesn't include the zoom base, so zoomStack().count() might be maxStackDepth() + 1.

Definition at line 145 of file qwt_plot_zoomer.cpp.

References zoom().

  void QwtPlotZoomer::setSelectionFlags (int flags) [virtual]

Set the selection flags

Parameters:
    flags Or'd value of QwtPicker::RectSelectionType and QwtPicker::SelectionMode. The default value is QwtPicker::RectSelection & QwtPicker::ClickSelection.

See also:
    selectionFlags(), SelectionType, RectSelectionType, SelectionMode

Note:
    QwtPicker::RectSelection will be auto added.

Reimplemented from QwtPicker.

Definition at line 619 of file qwt_plot_zoomer.cpp.

References QwtPicker::setSelectionFlags().

  void QwtPlotZoomer::setZoomBase (const QwtDoubleRect & base) [virtual]

Set the initial size of the zoomer.

base is united with the current scaleRect() and the zoom stack is reinitalized with it as zoom base. plot is zoomed to scaleRect().

Parameters:
    base Zoom base

See also:
    zoomBase(), scaleRect()

Definition at line 231 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::plot(), rescale(), and QwtPlotPicker::scaleRect().

  void QwtPlotZoomer::setZoomBase () [virtual]

Reinitialized the zoom stack with scaleRect() as base.

See also:
    zoomBase(), scaleRect()

Warning:
    Calling QwtPlot::setAxisScale() while QwtPlot::autoReplot() is false leaves the axis in an 'intermediate' state. In this case, to prevent buggy behaviour, you must call QwtPlot::replot() before calling QwtPlotZoomer::setZoomBase(). This quirk will be removed in a future release.

See also:
    QwtPlot::autoReplot(), QwtPlot::replot().

Definition at line 208 of file qwt_plot_zoomer.cpp.

References QwtPlotPicker::plot(), rescale(), and QwtPlotPicker::scaleRect().

Referenced by setAxis().

  void QwtPlotZoomer::widgetKeyPressEvent (QKeyEvent * ke) [protected, virtual]

Qt::Key_Plus zooms out, Qt::Key_Minus zooms in one position on the zoom stack, Qt::Key_Escape zooms out to the zoom base.

Changes the current position on the stack, but doesn't pop any rectangle.

Note:
    The keys codes can be changed, using QwtEventPattern::setKeyPattern: 3, 4, 5

Reimplemented from QwtPicker.

Definition at line 429 of file qwt_plot_zoomer.cpp.

References QwtPicker::isActive(), QwtEventPattern::keyMatch(), QwtPicker::widgetKeyPressEvent(), and zoom().

  void QwtPlotZoomer::widgetMouseReleaseEvent (QMouseEvent * me) [protected, virtual]

Qt::MidButton zooms out one position on the zoom stack, Qt::RightButton to the zoom base.

Changes the current position on the stack, but doesn't pop any rectangle.

Note:
    The mouse events can be changed, using QwtEventPattern::setMousePattern: 2, 1

Reimplemented from QwtPicker.

Definition at line 406 of file qwt_plot_zoomer.cpp.

References QwtEventPattern::mouseMatch(), QwtPicker::widgetMouseReleaseEvent(), and zoom().

  void QwtPlotZoomer::zoom (int offset) [virtual, slot]

Zoom in or out.

Activate a rectangle on the zoom stack with an offset relative to the current position. Negative values of offest will zoom out, positive zoom in. A value of 0 zooms out to the zoom base.

Parameters:
    offset Offset relative to the current position of the zoom stack.

Note:
    The zoomed signal is emitted.

See also:
    zoomRectIndex()

Definition at line 319 of file qwt_plot_zoomer.cpp.

References rescale(), zoomed(), and zoomRect().

  void QwtPlotZoomer::zoom (const QwtDoubleRect & rect) [virtual, slot]

Zoom in.

Clears all rectangles above the current position of the zoom stack and pushs the intersection of zoomRect() and the normalized rect on it.

Note:
    If the maximal stack depth is reached, zoom is ignored.

    The zoomed signal is emitted.

Definition at line 282 of file qwt_plot_zoomer.cpp.

References rescale(), zoomed(), and zoomRect().

Referenced by end(), setMaxStackDepth(), widgetKeyPressEvent(), and widgetMouseReleaseEvent().

  QwtDoubleRect QwtPlotZoomer::zoomBase () const

Returns:
    Initial rectangle of the zoomer

See also:
    setZoomBase(), zoomRect()

Definition at line 190 of file qwt_plot_zoomer.cpp.

Referenced by move().

  void QwtPlotZoomer::zoomed (const QwtDoubleRect & rect) [signal]

A signal emitting the zoomRect(), when the plot has been zoomed in or out.

Parameters:
    rect Current zoom rectangle.

Referenced by zoom().

  QwtDoubleRect QwtPlotZoomer::zoomRect () const

Rectangle at the current position on the zoom stack.

See also:
    QwtPlotZoomer::zoomRectIndex(), QwtPlotZoomer::scaleRect().

Definition at line 258 of file qwt_plot_zoomer.cpp.

Referenced by end(), move(), and zoom().

  uint QwtPlotZoomer::zoomRectIndex () const

Returns:
    Index of current position of zoom stack.

Definition at line 266 of file qwt_plot_zoomer.cpp.

  const QwtZoomStack & QwtPlotZoomer::zoomStack () const

Return the zoom stack. zoomStack()[0] is the zoom base, zoomStack()[1] the first zoomed rectangle.

Definition at line 181 of file qwt_plot_zoomer.cpp.

Author

Generated automatically by Doxygen for Qwt User's Guide from the source code.